;
;										
;	DarkRoom -40k Intro					by Dweezil				
;										
;
;final version using zenplayer

;ZEN
PT	;add. PT module player

		IFD	ASMONE
		incdir	"dh0:darkroom/"
		ENDC

		section	stellar,code

rot		equ	213
zmp		equ	437
part2_flash	equ	215
part2_tm	equ	430

part3_tm	equ	400

w_blit		macro
.\@wb		btst	#6,$002(a6)
		bne.b	.\@wb
		endm

go		move.l	$4.w,a6
		moveq	#0,d0
		lea	gfxname_0(pc),a1
		jsr	-$228(a6)
		move.l	d0,gfxbase_0
		beq	exit_0
		move.l	d0,a6
		move.l  $22(a6),wbview_0
		sub.l	a1,a1
		jsr 	-$de(a6)
		jsr	-$10e(a6)
		jsr	-$10e(a6)
	;	jsr	-$1e8(a6)
		jsr	-$e4(a6)

		IFD	ZEN
		bsr	z_init
		ENDC

		IFD	PT
		lea	mt_data,a0
		bsr	mt_init
		lea	vars,a0
		move.l	$6c.w,(a0)+
		move.w	$dff01c,(a0)+
		move.w	#$7fff,$dff09a
		lea	vbi,a0
		move.l	a0,$6c.w
		move.w	#$c020,$dff09a
		ENDC

		lea	$dff000,a6
		move	#$0020,$096(a6)
		clr.l	$140(a6)

	;	move	#$4000,$09a(a6)

		move.l	#copper_0,$080(a6)
		bsr	clbss_0
		bsr	go_part_1

		move.l	#copper_0,$080(a6)
		bsr	clbss_0
		bsr	go_part_2

		move.l	#copper_0,$080(a6)
		bsr	clbss_0
		bsr	go_part_3

		move.l	#copper_0,$080(a6)
		bsr	clbss_0
		bsr	go_part_4
	
		IFD	ZEN
		bsr	z_end
		ENDC

		IFD	PT
		lea	vars,a0
		move.w	#$7fff,$dff09a
		move.l	(a0)+,$6c.w
		move.w	(a0)+,d0
		ori.w	#$8000,d0
		move.w	d0,$dff09a
		bsr	mt_end
		ENDC

		move	#$8020,$dff096

		move.l	gfxbase_0(pc),a6
		jsr	-$e4(a6)
	;	jsr	-$1ce(a6)

		move.l	wbview_0(pc),a1
		jsr	-$de(a6)
		jsr	-$10e(a6)
		jsr	-$10e(a6)
		move.l	$26(a6),$dff080
		move.l	a6,a1
		move.l	$4.w,a6
		jsr	-$19e(a6)

exit_0		moveq	#0,d0
		rts

; Clear bss-hunk

clbss_0		moveq	#0,d0
		move.l	d0,d1
		move.l	d0,d2
		move.l	d0,d3
		move.l	d0,a0
		move.l	d0,a1
		move.l	d0,a2
		move.l	d0,a3

		lea	chip+chip_siz,a4
		move	#chip_siz>>8-1,d4
.clfast		rept	8
		movem.l	d0-d3/a0-a3,-(a4)
		endr
		dbf	d4,.clfast
		rts

gfxname_0	dc.b	"graphics.library",0
		even

gfxbase_0	dc.l	0
wbview_0	dc.l	0

;; <1>
;
;										
;	" S o l a r  W i n d "							
;										
;

go_part_1	bsr	s_init_1
		IFND	ZEN
		sf	stuff_1
		ENDC

mouse_1		bsr	do_wind_1

		move.l	#scopa_1,$080(a6)
		bsr	plus_1

		bsr	do_wind_1

		move.l	#scopb_1,$080(a6)
		bsr	minus_1

		IFND	ZEN
		cmp	#zmp+170,frame_1
		bhs.b	.x
		ENDC

		IFD	ZEN
		move.w	z_part1v,d0
		move.b	z_part1_8flgs,d1
		sf	stuff_1
		lea	fractar_1,a0
		cmpi.w	#4,d0
		bne.s	.notyet
		cmpi.b	#-$10,d1
		bcs.s	.sup
		lea	rotate_1,a0

.notyet		cmpi.w	#8,d0
		bne.s	.sup
		lea	rotate_1,a0

.sup		cmpi.w	#$c,d0
		bcs.s	.sup16
		lea	zoomaa_1,a0
.sup12		st	stuff_1
.sup16		cmpi.w	#$10,d0
		beq.s	.x
		move.l	a0,twist_1
		ENDC

		btst	#6,$bfe001
		bne.b	mouse_1

.x		rts

s_init_1	lea	sptra_1,a0
		move.l	#bpa1_1,d2
		lea	sptrb_1,a1
		move.l	#bpb1_1,d3
		moveq	#0,d1
		moveq	#3,d0
.1		move	d2,6(a0,d1.w)
		swap	d2
		move	d2,2(a0,d1.w)
		swap	d2	
		move	d3,6(a1,d1.w)
		swap	d3
		move	d3,2(a1,d1.w)
		swap	d3
		addq	#8,d1
		add.l	#10240,d2
		add.l	#10240,d3
		dbf	d0,.1

		lea	fractar_1,a0
		move	#$17f,d2
		move	#$181,d3
		bsr	do_prog_1

		lea	zoomaa_1,a0
		move	#-1,d2
		move	#$180,d3
		bsr	do_prog_1

		lea	rotate_1,a0
		move	#$180,d2
		move	#1,d3
		bsr	do_prog_1

		move.l	#scopa_1,$080(a6)

		rts

do_wind_1	addq	#1,frame_1
		
		IFND	ZEN
		moveq	#0,d0
		move	frame_1(pc),d0
		move.l	prgptr_1(pc),a0
		cmp.l	(a0),d0
		bne.b	.zop
		move.l	4(a0),d0
		move.l	d0,twist_1
		cmp.l	#zoomaa_1,d0
		bne.b	.2
		st	stuff_1
.2		addq.l	#8,prgptr_1
.zop
		ENDC

		bsr	do_pos_1
		bsr	do_tube_1
		bsr	do_blit_1
		bsr	do_bli2_1

		rts

frame_1		dc	0
twist_1		
		IFND	ZEN
		dc.l	hold_1
		ENDC
		IFD	ZEN
		dc.l	fractar_1
		ENDC

		IFND	ZEN
prgptr_1	dc.l	program_1

program_1	dc.l	1,fractar_1
		dc.l	rot,rotate_1
		dc.l	zmp,zoomaa_1
		dc.l	-1,-1
		ENDC

; calculate blit prog

do_prog_1	move	d3,d6
		asl	#2,d3
		move	d2,d5
		asl	#2,d2
		add	d5,d2
		moveq	#8,d1
.l1		move	d2,d7
		moveq	#10,d0
.l2		move	d3,d4
		add	d7,d4
		move	d4,(a0)+
		sub	d5,d7
		dbf	d0,.l2
		sub	d6,d3
		dbf	d1,.l1
		rts

; + laskuosuus		bpa -> bpb

plus_1		w_blit

		moveq	#0,d0
		move.l	d0,$040(a6)
		move.l	d0,$060(a6)
		move.l	d0,$064(a6)
		moveq	#-1,d0
		move.l	d0,$044(a6)

		move	#$0f80,$040(a6)		bpa2 and bpa3 and bpa4 -> t
		move.l	#bpa2_1,$050(a6)
		move.l	#bpa3_1,$04c(a6)
		move.l	#bpa4_1,$048(a6)
		move.l	#t_1,$054(a6)
		move	#$4014,$058(a6)

		w_blit

		move	#8,$062(a6)

		move	#$0fe6,$040(a6)		bpa1 + g -> bpb1
		move.l	#t_1,$050(a6)
		move.l	#g_1,$04c(a6)
		move.l	#bpa1_1,$048(a6)
		move.l	#bpb1_1,$054(a6)
		move	#$4014,$058(a6)

		w_blit

		move	#0,$062(a6)

		move	#$0f9a,$040(a6)		bpa2 + 1 -> bpb2
		move.l	#bpa1_1,$050(a6)
		move.l	#bpb1_1,$04c(a6)
		move.l	#bpa2_1,$048(a6)
		move.l	#bpb2_1,$054(a6)
		move	#$4014,$058(a6)

		w_blit

		move	#$0f9a,$040(a6)		bpa3 + 1 -> bpb3
		move.l	#bpa2_1,$050(a6)
		move.l	#bpb2_1,$04c(a6)
		move.l	#bpa3_1,$048(a6)
		move.l	#bpb3_1,$054(a6)
		move	#$4014,$058(a6)

		w_blit

		move	#$0f9a,$040(a6)		bpa4 + 1 -> bpb4
		move.l	#bpa3_1,$050(a6)
		move.l	#bpb3_1,$04c(a6)
		move.l	#bpa4_1,$048(a6)
		move.l	#bpb4_1,$054(a6)
		move	#$4014,$058(a6)

		rts


; - laskuosuus		bpb -> bpa

minus_1		w_blit

		moveq	#0,d0
		move.l	d0,$040(a6)
		move.l	d0,$060(a6)
		move.l	d0,$064(a6)
		moveq	#-1,d0
		move.l	d0,$044(a6)

		move	#$0f01,$040(a6)		bpb2 and bpb3 and bpb4 -> t
		move.l	#bpb2_1,$050(a6)
		move.l	#bpb3_1,$04c(a6)
		move.l	#bpb4_1,$048(a6)
		move.l	#t_1,$054(a6)
		move	#$4014,$058(a6)

		w_blit

		move	#8,$062(a6)
		move	#$0f89,$040(a6)		bpb1 - g -> bpa1
		move.l	#t_1,$050(a6)
		move.l	#g_1,$04c(a6)
		move.l	#bpb1_1,$048(a6)
		move.l	#bpa1_1,$054(a6)
		move	#$4014,$058(a6)

		w_blit

		move	#0,$062(a6)
		move	#$0fa6,$040(a6)		bpb2 - 1 -> bpa2
		move.l	#bpb1_1,$050(a6)
		move.l	#bpa1_1,$04c(a6)
		move.l	#bpb2_1,$048(a6)
		move.l	#bpa2_1,$054(a6)
		move	#$4014,$058(a6)

		w_blit

		move	#$0fa6,$040(a6)		bpb2 - 1 -> bpa2
		move.l	#bpb2_1,$050(a6)
		move.l	#bpa2_1,$04c(a6)
		move.l	#bpb3_1,$048(a6)
		move.l	#bpa3_1,$054(a6)
		move	#$4014,$058(a6)

		w_blit

		move	#$0fa6,$040(a6)		bpb2 - 1 -> bpa2
		move.l	#bpb3_1,$050(a6)
		move.l	#bpa3_1,$04c(a6)
		move.l	#bpb4_1,$048(a6)
		move.l	#bpa4_1,$054(a6)
		move	#$4014,$058(a6)

		rts


; put random stuff in the middle of the screen

do_tube_1	move.l	rand_1(pc),d0
		add	frame_1(pc),d0
	;	add.l	$004(a6),d0
		ror.l	#5,d0
		eor	#$1dc4,d0
		move.l	d0,rand_1

		lea	g_1,a0

		tst.b	stuff_1
		bne.b	.2

		moveq	#3,d1	
.1		eor.b	d0,126*48+19(a0)
		swap	d0
		eor.b	d0,126*48+20(a0)
		add	#48,a0
		add	a0,d0
		ror.l	#1,d0
		dbf	d1,.1
		rts

.2		moveq	#3,d1	
.3		clr.b	126*48+19(a0)
		clr.b	126*48+20(a0)
		add	#48,a0
		dbf	d1,.3
		rts

stuff_1		dc	0


; do the twist!

do_pos_1	moveq	#$1f,d0
		and	frame_1(pc),d0
		add	d0,d0
		lea	.tab(pc),a0
		move	(a0,d0),d0
		move	d0,apos_1
		rts

.tab	dc	%00000,%10000,%01000,%11000,%00100,%10100,%01100,%11100
	dc	%00010,%10010,%01010,%11010,%00110,%10110,%01110,%11110
	dc	%00001,%10001,%01001,%11001,%00101,%10101,%01101,%11101
	dc	%00011,%10011,%01011,%11011,%00111,%10111,%01111,%11111

apos_1		dc	0

; takaisinkopsublitti

do_bli2_1	move	apos_1(pc),d0
		muls	#24,d0
		move	apos_1(pc),d1
		asr	#4,d1
		add	d1,d0
		add	d0,d0
		ext.l	d0

		lea	t_1+$c0a,a0
		sub.l	d0,a0

		move	apos_1(pc),d1
		ror	#4,d1
		and	#$f000,d1
		or	#$09f0,d1

		w_blit

		move	d1,$040(a6)		t+logo -> g		
		move.l	#0,$044(a6)
		move.l	#$ffffffff,$044(a6)
		move.l	#$00000000,$060(a6)
		move.l	#$00000000,$064(a6)
		move.l	a0,$050(a6)
		move.l	#g_1,$054(a6)
		move	#$4018,$058(a6)

		rts

; blitter driver for zoomer

do_blit_1	lea	g_1-$c08,a0
		lea	t_1,a4

		move	apos_1(pc),d5
		move	d5,d4
		muls	#384,d5
		add	d4,d5
		subq	#1,d5

		move	#$0803,d3		bltsize
		move.l	twist_1(pc),a1
		add	#$62c,a4		start pos.
		add	#$62c,a0

		move	#$62c,d7		'modulo'
		moveq	#8,d6			loop counter

		lea	$dff002,a6

.blit1		btst	#6,(a6)			
		bne.b	.blit1

		move	#$0000,$042-2(a6)	clear bltcon1
		move.l	#$ffffffff,$044-2(a6)	set masks
		move.l	#$002a002a,$064-2(a6)	set modulos for A & D

.loop2		moveq	#10,d4
.loop1		move	(a1)+,d0
		add	d5,d0
		moveq	#$f,d2
		and	d0,d2
		add	d2,d2
		move	.con0(pc,d2),d2
		asr	#3,d0
		lea	(a0,d0),a3
.blit2		btst	#6,(a6)
		bne.b	.blit2
		move	d2,$040-2(a6)		set bltcon0
		movem.l	a3/a4,$050-2(a6)	set bltaptr & bltdptr
		move	d3,$058-2(a6)		set size
		subq	#4,a0
		subq	#4,a4
		dbf	d4,.loop1
		add	d7,a0
		add	d7,a4
		dbf	d6,.loop2
		lea	$dff000,a6
		rts

.con0		dc	$f9f0,$e9f0,$d9f0,$c9f0,$b9f0,$a9f0,$99f0,$89f0
		dc	$79f0,$69f0,$59f0,$49f0,$39f0,$29f0,$19f0,$09f0

rand_1		dc.l	$deadbeef

;; <2>
;
;															
;	" P a r t i c l e s "									
;										
;

go_part_2	lea	$dff000,a6

mouse_2		tst.b	5(a6)
		beq.b	mouse_2
.1		tst.b	5(a6)
		bne.b	.1

		IFND	ZEN
		bsr	laita2_2

		cmp	#part2_flash,frame_2
		bne.b	.rer
		bsr	laita1_2
		ENDC

.rer		movem.l	scr1_2(pc),d0-d3
		move.l	d0,d4
		move.l	d1,d0
		move.l	d2,d1
		move.l	d3,d2
		move.l	d4,d3
		movem.l	d0-d3,scr1_2

		move.l	d0,$0e0(a6)
		move.l	d1,$0e4(a6)
		move.l	d2,$0e8(a6)
		move.l	#bpl_tx_2,$0ec(a6)

		move	frame_2(pc),d0
		addq	#1,d0
		move	d0,frame_2

		move.l	parpt_2(pc),a0
		cmp	frame2_2(pc),d0
		bne.b	.3

		addq	#4,a0
		tst.b	1(a0)
		bpl.b	.2
		lea	param_2(pc),a0

.2		moveq	#0,d1
		move.b	(a0),d1
		add	d0,d1
		move	d1,frame2_2
		move.l	a0,parpt_2

.3		move.b	2(a0),d0
		move.b	3(a0),d1
	
		bsr	vaaka_2
		bsr	pysty_2

		move	frame_2(pc),d0

		IFND	ZEN
		cmp	#part2_tm+16,d0
		beq.b	.x

		cmp	#part2_tm,d0
		blo.b	.4
		ENDC
		
		IFD	ZEN
		move.w	z_part1v,d0
		move.b	z_part1_8flgs,d1
		cmpi.w	#24,d0
		beq.s	.x
		cmpi.w	#20,d0
		bne.s	.notyet
		cmpi.b	#-$20,d1
		bcs.s	.notyet
		ENDC
		bsr	fadeout_2

		IFD	ZEN
.notyet		andi.w	#$7c,d1
		cmpi.b	#$40,d1
		bne.s	.4
		bsr	laita1_2
		ENDC
.4
		IFD	ZEN
		bsr	laita2_2
		ENDC

		move.l	#copper_2,$080(a6)
		btst	#6,$bfe001
		bne	mouse_2

.x		rts

frame_2		dc	0
frame2_2	dc	1

parpt_2		dc.l	param_2

param_2		dc.b	1,$00,$05,$ff
		dc.b	1,$00,$02,$00
		dc.b	1,$00,$07,$ff
		dc.b	1,$00,$00,$00
		dc.b	1,$00,$01,$ff
		dc.b	1,$00,$06,$00
		dc.b	1,$00,$03,$ff
		dc.b	1,$00,$04,$00
		dc.l	-1

scr1_2		dc.l	bpl1_2
scr2_2		dc.l	bpl2_2
scr3_2		dc.l	bpl3_2
scr4_2		dc.l	bpl4_2

fadeout_2	lea	fadehere_2,a0
		moveq	#15,d3
.lo		addq	#2,a0
		move	(a0),d0
		move	d0,d1
		move	d0,d2

		and	#$000f,d0
		and	#$00f0,d1
		and	#$0f00,d2

		subq	#$0001,d0
		bpl.b	.1
		moveq	#0,d0
.1		sub	#$0010,d1
		bpl.b	.2
		moveq	#0,d1
.2		sub	#$0100,d2
		bpl.b	.3
		moveq	#0,d2
.3		or	d2,d0
		or	d1,d0
		move	d0,(a0)+

		dbf	d3,.lo				
		rts


laita1_2	move.l	scr2_2(pc),a0
		add	#112*40+18,a0
		moveq	#-1,d0
		moveq	#7,d1
.1		move.l	d0,(a0)
		move.l	d0,40(a0)
		move.l	d0,80(a0)
		move.l	d0,120(a0)
		add	#160,a0
		dbf	d1,.1
		rts

laita2_2
		move.l	scr2_2(pc),a0
		add	#112*40,a0
		lea	pic_2,a1
		lea	bpl_tx_2,a2
		add	#112*40,a2

		moveq	#31,d0
		and	frame_2(pc),d0
		mulu	#40,d0
		add	d0,a0
		add	d0,a1
		add	d0,a2

.1		rept	10
		move.l	(a1)+,d2
		or.l	d2,(a0)+
		move.l	d2,(a2)+
		endr
		rts

; vaakasuuntainen siirto

v_bsiz_2	=	$0105

vaaka_2		move.l	scr1_2(pc),a0
		lea	temp_2,a1

		move	#255,d4
		moveq	#40,d2

		w_blit
		moveq	#0,d3
		move	d3,$042(a6)
		move.l	d3,$064(a6)
		moveq	#-1,d3
		move.l	d3,$044(a6)

.lp		move	d1,d3
		eor	d4,d3
		btst	d0,d3

		beq.b	.bit1
		w_blit
		move	#$19f0,$040(a6)
		movem.l	a0/a1,$050(a6)
		move	#v_bsiz_2,$058(a6)
		add	d2,a0
		add	d2,a1
		dbf	d4,.lp
		rts

.bit1		addq	#2,a0
		w_blit
		move	#$f9f0,$040(a6)
		movem.l	a0/a1,$050(a6)
		move	#v_bsiz_2,$058(a6)
		add	#38,a0
		add	d2,a1
		dbf	d4,.lp
		rts

; pystypalkkien siirrot

pysty_2		lea	temp_2,a0
		lea	40(a0),a1
		sub	#40,a0
		move.l	scr2_2(pc),a2

		moveq	#-32,d2
		moveq	#19,d6

		w_blit
		move	#0,$042(a6)
		moveq	#38,d3
		move	d3,$062(a6)
		move	d3,$064(a6)
		move	d3,$066(a6)
		moveq	#-1,d3
		move.l	d3,$044(a6)

.ilo		moveq	#15,d5
.l1		move	d1,d3
		eor	d2,d3
		add	d4,d4
		btst	d0,d3
		bne.b	.l1z
		addq	#1,d4
.l1z		addq	#1,d2
		dbf	d5,.l1

		w_blit
		move	#$0dd8,$040(a6)
		movem.l	a0/a1/a2,$04c(a6)
		move	d4,$070(a6)
		move	#$4001,$058(a6)

		addq	#2,a0
		addq	#2,a1
		addq	#2,a2

		dbf	d6,.ilo
		rts

;; <3>
;
;										
;	" F i r e F l i e s "							
;											
;

offs_3		=	$780

go_part_3	lea	$dff000,a6

		bsr	init_3
		bsr	dosine_3

mouse_3		tst.b	5(a6)
		beq.b	mouse_3
.1		tst.b	5(a6)
		bne.b	.1

		addq	#1,frame_3

		move	#$7fe,d1

		move.l	posse_3(pc),d2
		add.l	speed_3(pc),d2
		move.l	d2,posse_3
		swap	d2
		add.l	#$800,speed_3
		move	d2,d0
		and	d1,d0

		lea	sin_3,a0
		lea	cos_3-sin_3(a0),a1
		lea	coords_3(pc),a2
		move	(a0,d0),(a2)+
		move	(a1,d0),(a2)+

		lsr	#1,d2
		add	#offs_3,d2
		move	d2,d0
		and	d1,d0
		move	(a0,d0),(a2)+
		move	(a1,d0),(a2)+

		lsr	#1,d2
		add	#offs_3,d2
		move	d2,d0
		and	d1,d0
		move	(a0,d0),(a2)+
		move	(a1,d0),(a2)+

		lsr	#1,d2
		add	#offs_3,d2
		move	d2,d0
		and	d1,d0
		move	(a0,d0),(a2)+
		move	(a1,d0),(a2)+

		lsr	#1,d2
		add	#offs_3,d2
		move	d2,d0
		and	d1,d0
		move	(a0,d0),(a2)+
		move	(a1,d0),(a2)+

		movem.l	coords_3-2(pc),d0-d4
		lea	star_3+512-160,a0
		lea	(a0,d1),a1
		lea	(a0,d2),a2
		lea	(a0,d3),a3
		lea	(a0,d4),a4
		add	d0,a0
		bsr	vaaka_3

		movem.l	coords_3(pc),d0-d4
		lea	star_3+512-128,a0
		lea	(a0,d1),a1
		lea	(a0,d2),a2
		lea	(a0,d3),a3
		lea	(a0,d4),a4
		add	d0,a0
		bsr	pysty_3

		move.l	cop2_3(pc),$080(a6)

		lea	ptexg_3(pc),a0
		movem.l	(a0),d0-d3
		exg	d0,d1
		exg	d2,d3
		movem.l	d0-d3,(a0)

		cmp	#part3_tm,frame_3
		beq.b	.x

		btst	#6,$bfe001
		bne	mouse_3
.x		rts

speed_3		dc.l	$80000
frame_3		dc	0
posse_3		dc.l	0

ptexg_3
cop1_3		dc.l	copper1_3
cop2_3		dc.l	copper2_3
scrl1_3		dc.l	line1_3
scrl2_3		dc.l	line2_3

coords_3	dc	0,0
		dc	0,0
		dc	0,0
		dc	0,0
		dc	0,0

; Calculate sin & cos lists using formula   sin a = a-a^3/3!+a^5/5!-a^7/7!
; 11 bits are used in the calculations for precision

dosine_3	lea	sin_3,a0
		lea	1024(a0),a1
		moveq	#0,d4

		move	#255,d3
.l1		move.l	d4,d0
		swap	d0
		add.l	#823550,d4	Pi<<18
		move	d0,d2
		move	d0,d1
		mulu	d1,d1
		lsl.l	#4,d1
		swap	d1
		mulu	d1,d0
		divu	#3<<11,d0
		sub	d0,d2
		mulu	d1,d0
		divu	#10<<11,d0
		add	d0,d2
		mulu	d1,d0
		divu	#21<<11,d0
		sub	d0,d2
		asr	#4,d2

		move	d2,(a0)+
		move	d2,2046(a0)
		move	d2,-(a1)
		neg	d2
		move	d2,1022(a0)
		move	d2,1024(a1)

		dbf	d3,.l1
		rts

; inittialiohjelma 

init_3		lea	l_even_3,a1		Muodostetaan 1/0 bittitasot
		lea	l_odd_3,a0
		moveq	#-1,d1
		moveq	#9,d0
.1		move.l	d1,(a0)+
		clr.l	(a1)+
		dbf	d0,.1

		lea	copst_3(pc),a0		kopsataan copperlistat
		move.l	cop1_3(pc),a1
		move.l	cop2_3(pc),a2
		moveq	#copstl_3>>2-1,d0
.c1		move.l	(a0),(a1)+
		move.l	(a0)+,(a2)+
		dbf	d0,.c1

		move.l	scrl1_3(pc),d0		laitetaan niihin bpl-pointterit
		move.l	cop1_3(pc),a0
		bsr	.cz
		move.l	scrl2_3(pc),d0
		move.l	cop2_3(pc),a0
		bsr	.cz

		bsr	inz_cl_3
		bsr	do_sqt_3

		rts	

;

.cz		moveq	#4-1,d1			Asettaa bpl-pointterit copperlistaan
.cz1		move	d0,bploff_3+4(a0)
		swap	d0
		move	d0,bploff_3(a0)
		swap	d0
		addq	#8,a0
		add.l	#40,d0
		dbf	d1,.cz1
		rts

copst_3		dc	$008e,$2c81,$0090,$2cc1		Copperlistan alku
		dc	$0092,$0038,$0094,$00d0
		dc	$0100,$5000,$0102,$0000
		dc	$0104,$0000,$0180,$0000
		dc	$0108,$ffd8,$010a,$ffd8
bploff_3	=	*-copst_3+2
		dc	$00e0,$0000,$00e2,$0000
		dc	$00e4,$0000,$00e6,$0000
		dc	$00e8,$0000,$00ea,$0000
		dc	$00ec,$0000,$00ee,$0000
copstl_3	=	*-copst_3

; varilistat yms. rakennetaan

inz_cl_3	lea	cmaps_3,a0
		lea	$1200(a0),a1
		lea	.ctab(pc),a3
		lea	cptab_3,a4

		moveq	#0,d4

		moveq	#$3f,d7
.1		move.l	a0,(a4)+

		move.l	#l_even_3,d1
		move	#$00f2,(a0)+
		move	d1,(a0)+
		move	#$00f0,(a0)+
		swap	d1
		move	d1,(a0)+

		move.l	#l_odd_3,d1
		move	#$00f2,(a1)+
		move	d1,(a1)+
		move	#$00f0,(a1)+
		swap	d1
		move	d1,(a1)+

		move	#$0180,d1

		move	#$01a0,d2
		moveq	#$f,d6
.2		and	#$7e,d4
		move	(a3,d4),d3
		addq	#8,d4
		move	d1,(a0)+
		move	d3,(a0)+
		move	d2,(a1)+
		move	d3,(a1)+
		addq	#2,d1	
		addq	#2,d2
		dbf	d6,.2
		addq	#2,d4

		dbf	d7,.1
		rts


.ctab	dcb.w	24,0

	dc	$000,$001,$002,$003,$004,$005,$006,$007
	dc	$008,$009,$00a,$00b,$00c,$00d,$00e,$00f
	dc	$22f,$44f,$88f,$aaf,$ccf,$eef,$fff,$fff
	dc	$fff,$fff,$fff,$fff,$fff,$eef,$ccf,$aaf
	dc	$88f,$11e,$00c,$00a,$008,$006,$004,$002
	dcb.w	32,0

	dc	$000,$001,$002,$003,$004,$005,$006,$007
	dc	$008,$009,$00a,$00b,$00c,$00d,$00e,$00f
	dc	$00e,$00d,$01c,$02b,$03a,$049,$058,$067
	dc	$076,$085,$094,$0a3,$0b2,$0c1,$0d0,$0e0
	dc	$0f0,$0e0,$0d0,$1c0,$2b0,$3a0,$490,$580
	dc	$670,$760,$850,$940,$a30,$b20,$c10,$d00
	dc	$e00,$f00,$e00,$d00,$c00,$b00,$a00,$900
	dc	$800,$700,$600,$500,$400,$300,$200,$100

; muodostetaan taulukkoja

do_sqt_3	lea	star_3,a0
		lea	1024(a0),a1
		move	#511,d0
.1		moveq	#5,d2
		add	d0,d2
		move.l	#$100,d1
		divu	d2,d1	

		move.b	d1,(a0)+
		move.b	d1,-(a1)
		dbf	d0,.1
		rts

; rakennetaan copperlista

pysty_3		move.l	#$2c01fffe,d1
		move.l	#$01000000,d2

		move.l	cop2_3(pc),a5
		add	#copstl_3,a5

		moveq	#$7f,d3

		w_blit

		move.l	#$09f00000,$040(a6)
		move.l	#$ffffffff,$044(a6)
		move.l	#$00000000,$064(a6)

.zoka		move.b	(a0)+,d0		Even line
		add.b	(a1)+,d0
		add.b	(a2)+,d0
		add.b	(a3)+,d0
		add.b	(a4)+,d0

		and	#$fc,d0
		move.l	cptab_3(pc,d0),d0

		move.l	d1,(a5)+
		add.l	d2,d1

		w_blit

		move.l	d0,$050(a6)
		move.l	a5,$054(a6)
		move	#$0109,$058(a6)
		add	#$48,a5

		move.b	(a0)+,d0		Odd line
		add.b	(a1)+,d0
		add.b	(a2)+,d0
		add.b	(a3)+,d0
		add.b	(a4)+,d0

		and	#$fc,d0
		move.l	cptab_3(pc,d0),d0
		add.l	#$1200,d0
		move.l	d1,(a5)+
		add.l	d2,d1
		bcc.b	.b3
		move.l	#$ffe1fffe,(a5)+

.b3		w_blit

		move.l	d0,$050(a6)
		move.l	a5,$054(a6)
		move	#$0109,$058(a6)
		add	#$48,a5

		dbf	d3,.zoka

		move.l	#$01800000,(a5)+

		move.l	#-2,(a5)+
		rts
	
cptab_3		ds.l	$40

; rakennetaan vaakarivi

vaaka_3		move.l	scrl2_3(pc),a5
		moveq	#9,d7
.a		moveq	#15,d5
.b		rept	2
		move.b	(a0)+,d0
		add.b	(a1)+,d0
		add.b	(a2)+,d0
		add.b	(a3)+,d0
		add.b	(a4)+,d0
		add.b	d0,d0
		addx.l	d4,d4
		add.b	d0,d0
		addx.l	d3,d3
		add.b	d0,d0
		addx.l	d2,d2
		add.b	d0,d0
		addx.l	d1,d1
		endr
		dbf	d5,.b
		move.l	d4,120(a5)
		move.l	d3,80(a5)
		move.l	d2,40(a5)
		move.l	d1,(a5)+
		dbf	d7,.a
		rts

;; <4>
;
;										
;	" L a z e r s "								
;										
;

lines_4		=	64

go_part_4	lea	$dff000,a6

		move.b	#$ac,lin1_4
		move.b	#$ac,lin2_4

		bsr	do_sine_4

mouse_4		tst.b	5(a6)
		beq.b	mouse_4
.1		tst.b	5(a6)
		bne.b	.1

		bsr.b	avaa_4

		movem.l	scr1_4(pc),d0-d1
		exg	d0,d1
		movem.l	d0-d1,scr1_4

		add.l	#$500,d0
		move.l	d0,$0e0(a6)
		move.l	d0,$0e4(a6)
		move.l	#pic_4,$0e8(a6)

		addq	#1,frame_4

		bsr	clear_4
		bsr	radat_4
		bsr	dolines_4

		move.l	#copper_4,$080(a6)

		btst	#6,$bfe001
		bne	mouse_4

		rts

frame_4		dc	0

avaa_4		move.b	lin1_4,d0
		cmp.b	#$99,d0
		beq.b	.x
		subq.b	#1,lin1_4
		addq.b	#1,lin2_4
.x		rts

; Clear

clear_4		w_blit
		move.l	#$01000000,$040(a6)
		move	#0,$066(a6)
		move.l	scr2_4(pc),a0
		add	#32*40,a0
		move.l	a0,$054(a6)
		move	#$4014,$058(a6)
		rts

; Laskee radat

radat_4		move.l	#$ffff,d2
		move	frame_4(pc),d6
		moveq	#$40,d0
		sub	d6,d0
		bmi.b	.fg

		asr	#2,d0
		ror.l	d0,d2

.fg		moveq	#0,d5
		sub	#$20,d6
		add	d6,d6

		ror	d6,d2
		move	d6,d7

.lp		lea	sin_4,a1
		lea	rata_4,a2

		move	frame_4(pc),d5

		btst	#8,d5
		bne.b	.sfg
		not	d5
		add	#$100,d5
.sfg		sub	#$80,d5
		ext	d5
		asl	#4,d5

		and	#$fe,d6
		and	#$fe,d7

		moveq	#lines_4-1,d4

.zp		move	d5,d0
		add	(a1,d7),d0
		add	(a1,d6),d0
		move	64(a1,d7),d1
		add	64(a1,d6),d1

		move	d0,(a2)+
		move	d1,(a2)+
		move	d2,(a2)+

		ror	#1,d2

		addq.b	#4,d6
		addq.b	#8,d7

		dbf	d4,.zp

		rts


; Lineprutku

dolines_4	move.l	scr2_4(pc),a0
		add	#6420,a0
		lea	rata_4,a1

		w_blit			Init line
		moveq	#-1,d2
		move.l	d2,$044(a6)

		moveq	#40,d2
		move	d2,$060(a6)
		move	d2,$066(a6)
		move	#$8000,$074(a6)

		moveq	#lines_4-1,d5

.ll		movem	(a1)+,d0/d1/d4
		moveq	#0,d2		Draw the line
		tst	d0
		bpl.b	.1
		neg	d0
		moveq	#16,d2
.1		tst	d1
		bpl.b	.2
		neg	d1
		addq	#8,d2
.2		cmp	d0,d1
		blo.b	.3
		bne.b	.z
		tst	d0
		beq.b	.x
.z		exg	d0,d1
		addq	#4,d2
		move	#$2002,d3
		bra.b	.4
.3		move	#$2802,d3
.4		add	d1,d1

		w_blit

		move	d4,$072(a6)
		move.l	a0,$048(a6)
		move.l	a0,$054(a6)
		move	d1,$062(a6)
		sub	d0,d1
		bpl.b	.5
		addq	#2,d2
.5		move	#$0bea,$040(a6)
		move	.bcon0(pc,d2),$042(a6)
		move	d1,$052(a6)
		sub	d0,d1
		move	d1,$064(a6)
		move	d3,$058(a6)

.x		dbf	d5,.ll
		rts

.bcon0		dc	%0010001,%1010001
		dc	%0000001,%1000001
		dc	%0011001,%1011001
		dc	%0000101,%1000101
		dc	%0010101,%1010101
		dc	%0001001,%1001001
		dc	%0011101,%1011101
		dc	%0001101,%1001101

; Calculate sin & cos lists using formula   sin a = a-a^3/3!+a^5/5!-a^7/7!
; 11 bits are used in the calculations for precision

do_sine_4	lea	sin_4,a0
		lea	128(a0),a1

		move.l	#823550<<2,d4
		moveq	#31,d3
.l1		move.l	d4,d0
		swap	d0
		add.l	#823550<<3,d4	Pi<<18
		move	d0,d2
		move	d0,d1
		mulu	d1,d1
		lsl.l	#4,d1
		swap	d1
		mulu	d1,d0
		divu	#3<<11,d0
		sub	d0,d2
		mulu	d1,d0
		divu	#10<<11,d0
		add	d0,d2
		mulu	d1,d0
		divu	#21<<11,d0
		sub	d0,d2
		asr	#2,d2

		move	d2,(a0)+
		move	d2,254(a0)
		move	d2,-(a1)
		neg	d2
		move	d2,126(a0)
		move	d2,128(a1)

		dbf	d3,.l1
		rts

scr1_4		dc.l	bpl1_4
scr2_4		dc.l	bpl2_4


;; <6>
		
		IFD	ZEN
		include "zpreplay.s"

biisi		incbin	"darkroom.zen"
biisi_l		= *-biisi
		even
		ENDC

		IFD	PT
vars		ds.l	1
		ds.w	1

vbi		movem.l	d0-d7/a0-a6,-(sp)
		bsr	mt_music
		move.w	#$20,$dff09c
		move.w	#$20,$dff09c
		movem.l	(sp)+,d0-d7/a0-a6
		rte

		include	"ptreplay.s"
		ENDC

pic_2		incbin	"darkroom.raw"

;	bss (fast) 

	section	ada,bss

fast_siz	=	$1000
fast		ds.b	fast_siz

fractar_1	=	fast
zoomaa_1	=	fast+200
rotate_1	=	fast+400
hold_1		=	fast+600

sin_3		=	fast
cos_3		=	fast+$200
star_3		=	fast+$a00

sin_4		=	fast
rata_4		=	fast+360
	;(ds.w 3*lines)

;	bss-chip 

	section	we,bss_c

z_data		ds.b	$10000
chip_siz	=	$30000
chip		ds.b	chip_siz

g_1		=	chip
bpa1_1		=	chip+$3000
bpa2_1		=	chip+$5800
bpa3_1		=	chip+$8000
bpa4_1		=	chip+$a800
bpb1_1		=	chip+$d000
bpb2_1		=	chip+$f800
bpb3_1		=	chip+$12000
bpb4_1		=	chip+$14800
t_1		=	chip+$18000

bpl1_2		=	chip
temp_2		=	chip+$2828
bpl2_2		=	chip+$5050
bpl3_2		=	chip+$7850
bpl4_2		=	chip+$a050
bpl_tx_2	=	chip+$c850

line1_3		=	chip
line2_3		=	chip+160
l_even_3	=	chip+320
l_odd_3		=	chip+360
copper1_3	=	chip+400
copper2_3	=	chip+$5190
cmaps_3		=	chip+$a190

bpl1_4		=	chip
bpl2_4		=	chip+$3200
bpl3_4		=	chip+$6400


;	copperlistat, ym chip-kama 

	section	rw,data_c

copper_0	dc	$0100,$0000,$0180,$0000
		dc.l	-2

; routine 1

scopa_1		dc	$008e,$2c81,$0090,$2cc1
		dc	$0092,$0038,$0094,$00d0
		dc	$0108,$0000,$010a,$0000
		dc	$0100,$4000,$0102,$0000

	;	dc	$0180,$0000,$0182,$0100,$0184,$0200,$0186,$0300
	;	dc	$0188,$0400,$018a,$0500,$018c,$0600,$018e,$0700
	;	dc	$0190,$0800,$0192,$0910,$0194,$0a20,$0196,$0b30
	;	dc	$0198,$0c40,$019a,$0d50,$019c,$0e60,$019e,$0f70

		dc	$0180,$0000,$0182,$0001,$0184,$0002,$0186,$0003
		dc	$0188,$0004,$018a,$0005,$018c,$0006,$018e,$0007
		dc	$0190,$0008,$0192,$0009,$0194,$000a,$0196,$000b
		dc	$0198,$000c,$019a,$000d,$019c,$000e,$019e,$000f

sptra_1		dc	$00e0,$0000,$00e2,$0000
		dc	$00e4,$0000,$00e6,$0000
		dc	$00e8,$0000,$00ea,$0000
		dc	$00ec,$0000,$00ee,$0000
		dc.l	-2
scopb_1
sptrb_1		dc	$00e0,$0000,$00e2,$0000
		dc	$00e4,$0000,$00e6,$0000
		dc	$00e8,$0000,$00ea,$0000
		dc	$00ec,$0000,$00ee,$0000
		dc.l	-2

; routine 2

copper_2	dc	$008e,$2c81,$0090,$2cc1
		dc	$0092,$0038,$0094,$00d0
		dc	$0100,$4000,$0102,$0000
		dc	$0108,$0000,$010a,$0000
	
fadehere_2	dc	$0180,$0000,$0182,$0226,$0184,$0226,$0186,$033a
		dc	$0188,$0226,$018a,$033a,$018c,$033a,$018e,$044f
		dc	$0190,$044f,$0192,$066f,$0194,$066f,$0196,$0aaf
		dc	$0198,$066f,$019a,$0aaf,$019c,$0aaf,$019e,$0fff

		dc.l	-2

; routine 4

copper_4	dc	$008e,$2c81,$0090,$2cc1
		dc	$0092,$0038,$0094,$00d0
		dc	$0100,$2000,$0102,$0001
		dc	$0108,$0000,$010a,$0000
		dc	$0180,$0000,$0182,$0006,$0184,$0006,$0186,$000c
		dc	$0188,$0ccc,$018a,$0ccf,$018c,$0ccf,$018e,$0ccf
lin1_4		dc	$9911,$fffe,$0100,$3000
lin2_4		dc	$bf11,$fffe,$0100,$2000
		dc.l	-2

pic_4		incbin	"credits.raw"	

		IFD	PT
mt_data		incbin	"darkroom.mod"
		ENDC
